create table sites(
	site_id serial,
	url varchar(255),
	title varchar(255),
	short_desc text,
	indexdate date,
	spider_depth int default 2,
	required text,
	disallowed text,
	can_leave_domain smallint);
create table links (
	link_id serial,
	site_id int,
	url varchar(255) not null,
	title varchar(200),
	description varchar(255),
	fulltxt text,
	indexdate date,
	size float(2),
	md5_sum varchar(32), -- md5sum is a reserved word
	visible int default 0, 
	level int,
	primary key (url,md5_sum));
create table keywords	(
	keyword_id serial,
	keyword varchar(30) not null unique);
create table link_keyword0 (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyword1 (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyword2 (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyword3 (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyword4 (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyword5 (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyword6 (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyword7 (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyword8 (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyword9 (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyworda (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keywordb (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keywordc (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keywordd (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keyworde (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table link_keywordf (
	link_id int not null,
	keyword_id int not null,
	weight int,
	domain int,
	primary key (link_id, keyword_id)
	);
create table categories(
	category_id serial, 
	category text,
	parent_num integer
	);
create table site_category (
	site_id integer,
	category_id integer
	);
create table temp (
	link varchar(255),
	level integer,
	id varchar (32)
	);
create table pending (
	site_id integer,
	temp_id varchar(32),
	level integer,
	count integer,
	num integer);

create table query_log (
	query varchar(255),
	time timestamp(14),
	elapsed float(2),
	results int
	);

create table domains (
	domain_id serial,	
	domain varchar(255)
);


CREATE OR REPLACE FUNCTION soundex(text) RETURNS text
AS '$libdir/fuzzystrmatch', 'soundex'
LANGUAGE C IMMUTABLE STRICT;

